/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
	"time"
)

// checks if the Interaction type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &Interaction{}

// Interaction struct for Interaction
type Interaction struct {
	Id string `json:"id"`
	ChannelId string `json:"channel_id"`
	OrganizationId string `json:"organization_id"`
	Name string `json:"name"`
	Priority int32 `json:"priority"`
	ActionExecutionsLimit int32 `json:"action_executions_limit"`
	State State `json:"state"`
	Trigger Trigger `json:"trigger"`
	Actions []Action `json:"actions"`
	// When `true` new transaction will always be created on interaction start
	ForceNewTransaction bool `json:"force_new_transaction"`
	Restart bool `json:"restart"`
	RestartCoolDown *string `json:"restart_cool_down,omitempty"`
	LiveFrom *time.Time `json:"live_from,omitempty"`
	LiveTo *time.Time `json:"live_to,omitempty"`
	Tags []string `json:"tags,omitempty"`
	Languages []string `json:"languages,omitempty"`
	Messengers []string `json:"messengers,omitempty"`
	Metrics []Metric `json:"metrics,omitempty"`
	TimeZone *string `json:"time_zone,omitempty"`
	DefaultLanguage *string `json:"default_language,omitempty"`
	Successor *Successor `json:"successor,omitempty"`
	CreatedAt time.Time `json:"created_at"`
	UpdatedAt time.Time `json:"updated_at"`
}

// NewInteraction instantiates a new Interaction object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewInteraction(id string, channelId string, organizationId string, name string, priority int32, actionExecutionsLimit int32, state State, trigger Trigger, actions []Action, forceNewTransaction bool, restart bool, createdAt time.Time, updatedAt time.Time) *Interaction {
	this := Interaction{}
	this.Id = id
	this.ChannelId = channelId
	this.OrganizationId = organizationId
	this.Name = name
	this.Priority = priority
	this.ActionExecutionsLimit = actionExecutionsLimit
	this.State = state
	this.Trigger = trigger
	this.Actions = actions
	this.ForceNewTransaction = forceNewTransaction
	this.Restart = restart
	this.CreatedAt = createdAt
	this.UpdatedAt = updatedAt
	return &this
}

// NewInteractionWithDefaults instantiates a new Interaction object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewInteractionWithDefaults() *Interaction {
	this := Interaction{}
	return &this
}

// GetId returns the Id field value
func (o *Interaction) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *Interaction) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *Interaction) SetId(v string) {
	o.Id = v
}

// GetChannelId returns the ChannelId field value
func (o *Interaction) GetChannelId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value
// and a boolean to check if the value has been set.
func (o *Interaction) GetChannelIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ChannelId, true
}

// SetChannelId sets field value
func (o *Interaction) SetChannelId(v string) {
	o.ChannelId = v
}

// GetOrganizationId returns the OrganizationId field value
func (o *Interaction) GetOrganizationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OrganizationId
}

// GetOrganizationIdOk returns a tuple with the OrganizationId field value
// and a boolean to check if the value has been set.
func (o *Interaction) GetOrganizationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OrganizationId, true
}

// SetOrganizationId sets field value
func (o *Interaction) SetOrganizationId(v string) {
	o.OrganizationId = v
}

// GetName returns the Name field value
func (o *Interaction) GetName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Name
}

// GetNameOk returns a tuple with the Name field value
// and a boolean to check if the value has been set.
func (o *Interaction) GetNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Name, true
}

// SetName sets field value
func (o *Interaction) SetName(v string) {
	o.Name = v
}

// GetPriority returns the Priority field value
func (o *Interaction) GetPriority() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Priority
}

// GetPriorityOk returns a tuple with the Priority field value
// and a boolean to check if the value has been set.
func (o *Interaction) GetPriorityOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Priority, true
}

// SetPriority sets field value
func (o *Interaction) SetPriority(v int32) {
	o.Priority = v
}

// GetActionExecutionsLimit returns the ActionExecutionsLimit field value
func (o *Interaction) GetActionExecutionsLimit() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.ActionExecutionsLimit
}

// GetActionExecutionsLimitOk returns a tuple with the ActionExecutionsLimit field value
// and a boolean to check if the value has been set.
func (o *Interaction) GetActionExecutionsLimitOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ActionExecutionsLimit, true
}

// SetActionExecutionsLimit sets field value
func (o *Interaction) SetActionExecutionsLimit(v int32) {
	o.ActionExecutionsLimit = v
}

// GetState returns the State field value
func (o *Interaction) GetState() State {
	if o == nil {
		var ret State
		return ret
	}

	return o.State
}

// GetStateOk returns a tuple with the State field value
// and a boolean to check if the value has been set.
func (o *Interaction) GetStateOk() (*State, bool) {
	if o == nil {
		return nil, false
	}
	return &o.State, true
}

// SetState sets field value
func (o *Interaction) SetState(v State) {
	o.State = v
}

// GetTrigger returns the Trigger field value
func (o *Interaction) GetTrigger() Trigger {
	if o == nil {
		var ret Trigger
		return ret
	}

	return o.Trigger
}

// GetTriggerOk returns a tuple with the Trigger field value
// and a boolean to check if the value has been set.
func (o *Interaction) GetTriggerOk() (*Trigger, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Trigger, true
}

// SetTrigger sets field value
func (o *Interaction) SetTrigger(v Trigger) {
	o.Trigger = v
}

// GetActions returns the Actions field value
func (o *Interaction) GetActions() []Action {
	if o == nil {
		var ret []Action
		return ret
	}

	return o.Actions
}

// GetActionsOk returns a tuple with the Actions field value
// and a boolean to check if the value has been set.
func (o *Interaction) GetActionsOk() ([]Action, bool) {
	if o == nil {
		return nil, false
	}
	return o.Actions, true
}

// SetActions sets field value
func (o *Interaction) SetActions(v []Action) {
	o.Actions = v
}

// GetForceNewTransaction returns the ForceNewTransaction field value
func (o *Interaction) GetForceNewTransaction() bool {
	if o == nil {
		var ret bool
		return ret
	}

	return o.ForceNewTransaction
}

// GetForceNewTransactionOk returns a tuple with the ForceNewTransaction field value
// and a boolean to check if the value has been set.
func (o *Interaction) GetForceNewTransactionOk() (*bool, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ForceNewTransaction, true
}

// SetForceNewTransaction sets field value
func (o *Interaction) SetForceNewTransaction(v bool) {
	o.ForceNewTransaction = v
}

// GetRestart returns the Restart field value
func (o *Interaction) GetRestart() bool {
	if o == nil {
		var ret bool
		return ret
	}

	return o.Restart
}

// GetRestartOk returns a tuple with the Restart field value
// and a boolean to check if the value has been set.
func (o *Interaction) GetRestartOk() (*bool, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Restart, true
}

// SetRestart sets field value
func (o *Interaction) SetRestart(v bool) {
	o.Restart = v
}

// GetRestartCoolDown returns the RestartCoolDown field value if set, zero value otherwise.
func (o *Interaction) GetRestartCoolDown() string {
	if o == nil || IsNil(o.RestartCoolDown) {
		var ret string
		return ret
	}
	return *o.RestartCoolDown
}

// GetRestartCoolDownOk returns a tuple with the RestartCoolDown field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Interaction) GetRestartCoolDownOk() (*string, bool) {
	if o == nil || IsNil(o.RestartCoolDown) {
		return nil, false
	}
	return o.RestartCoolDown, true
}

// HasRestartCoolDown returns a boolean if a field has been set.
func (o *Interaction) HasRestartCoolDown() bool {
	if o != nil && !IsNil(o.RestartCoolDown) {
		return true
	}

	return false
}

// SetRestartCoolDown gets a reference to the given string and assigns it to the RestartCoolDown field.
func (o *Interaction) SetRestartCoolDown(v string) {
	o.RestartCoolDown = &v
}

// GetLiveFrom returns the LiveFrom field value if set, zero value otherwise.
func (o *Interaction) GetLiveFrom() time.Time {
	if o == nil || IsNil(o.LiveFrom) {
		var ret time.Time
		return ret
	}
	return *o.LiveFrom
}

// GetLiveFromOk returns a tuple with the LiveFrom field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Interaction) GetLiveFromOk() (*time.Time, bool) {
	if o == nil || IsNil(o.LiveFrom) {
		return nil, false
	}
	return o.LiveFrom, true
}

// HasLiveFrom returns a boolean if a field has been set.
func (o *Interaction) HasLiveFrom() bool {
	if o != nil && !IsNil(o.LiveFrom) {
		return true
	}

	return false
}

// SetLiveFrom gets a reference to the given time.Time and assigns it to the LiveFrom field.
func (o *Interaction) SetLiveFrom(v time.Time) {
	o.LiveFrom = &v
}

// GetLiveTo returns the LiveTo field value if set, zero value otherwise.
func (o *Interaction) GetLiveTo() time.Time {
	if o == nil || IsNil(o.LiveTo) {
		var ret time.Time
		return ret
	}
	return *o.LiveTo
}

// GetLiveToOk returns a tuple with the LiveTo field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Interaction) GetLiveToOk() (*time.Time, bool) {
	if o == nil || IsNil(o.LiveTo) {
		return nil, false
	}
	return o.LiveTo, true
}

// HasLiveTo returns a boolean if a field has been set.
func (o *Interaction) HasLiveTo() bool {
	if o != nil && !IsNil(o.LiveTo) {
		return true
	}

	return false
}

// SetLiveTo gets a reference to the given time.Time and assigns it to the LiveTo field.
func (o *Interaction) SetLiveTo(v time.Time) {
	o.LiveTo = &v
}

// GetTags returns the Tags field value if set, zero value otherwise.
func (o *Interaction) GetTags() []string {
	if o == nil || IsNil(o.Tags) {
		var ret []string
		return ret
	}
	return o.Tags
}

// GetTagsOk returns a tuple with the Tags field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Interaction) GetTagsOk() ([]string, bool) {
	if o == nil || IsNil(o.Tags) {
		return nil, false
	}
	return o.Tags, true
}

// HasTags returns a boolean if a field has been set.
func (o *Interaction) HasTags() bool {
	if o != nil && !IsNil(o.Tags) {
		return true
	}

	return false
}

// SetTags gets a reference to the given []string and assigns it to the Tags field.
func (o *Interaction) SetTags(v []string) {
	o.Tags = v
}

// GetLanguages returns the Languages field value if set, zero value otherwise.
func (o *Interaction) GetLanguages() []string {
	if o == nil || IsNil(o.Languages) {
		var ret []string
		return ret
	}
	return o.Languages
}

// GetLanguagesOk returns a tuple with the Languages field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Interaction) GetLanguagesOk() ([]string, bool) {
	if o == nil || IsNil(o.Languages) {
		return nil, false
	}
	return o.Languages, true
}

// HasLanguages returns a boolean if a field has been set.
func (o *Interaction) HasLanguages() bool {
	if o != nil && !IsNil(o.Languages) {
		return true
	}

	return false
}

// SetLanguages gets a reference to the given []string and assigns it to the Languages field.
func (o *Interaction) SetLanguages(v []string) {
	o.Languages = v
}

// GetMessengers returns the Messengers field value if set, zero value otherwise.
func (o *Interaction) GetMessengers() []string {
	if o == nil || IsNil(o.Messengers) {
		var ret []string
		return ret
	}
	return o.Messengers
}

// GetMessengersOk returns a tuple with the Messengers field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Interaction) GetMessengersOk() ([]string, bool) {
	if o == nil || IsNil(o.Messengers) {
		return nil, false
	}
	return o.Messengers, true
}

// HasMessengers returns a boolean if a field has been set.
func (o *Interaction) HasMessengers() bool {
	if o != nil && !IsNil(o.Messengers) {
		return true
	}

	return false
}

// SetMessengers gets a reference to the given []string and assigns it to the Messengers field.
func (o *Interaction) SetMessengers(v []string) {
	o.Messengers = v
}

// GetMetrics returns the Metrics field value if set, zero value otherwise.
func (o *Interaction) GetMetrics() []Metric {
	if o == nil || IsNil(o.Metrics) {
		var ret []Metric
		return ret
	}
	return o.Metrics
}

// GetMetricsOk returns a tuple with the Metrics field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Interaction) GetMetricsOk() ([]Metric, bool) {
	if o == nil || IsNil(o.Metrics) {
		return nil, false
	}
	return o.Metrics, true
}

// HasMetrics returns a boolean if a field has been set.
func (o *Interaction) HasMetrics() bool {
	if o != nil && !IsNil(o.Metrics) {
		return true
	}

	return false
}

// SetMetrics gets a reference to the given []Metric and assigns it to the Metrics field.
func (o *Interaction) SetMetrics(v []Metric) {
	o.Metrics = v
}

// GetTimeZone returns the TimeZone field value if set, zero value otherwise.
func (o *Interaction) GetTimeZone() string {
	if o == nil || IsNil(o.TimeZone) {
		var ret string
		return ret
	}
	return *o.TimeZone
}

// GetTimeZoneOk returns a tuple with the TimeZone field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Interaction) GetTimeZoneOk() (*string, bool) {
	if o == nil || IsNil(o.TimeZone) {
		return nil, false
	}
	return o.TimeZone, true
}

// HasTimeZone returns a boolean if a field has been set.
func (o *Interaction) HasTimeZone() bool {
	if o != nil && !IsNil(o.TimeZone) {
		return true
	}

	return false
}

// SetTimeZone gets a reference to the given string and assigns it to the TimeZone field.
func (o *Interaction) SetTimeZone(v string) {
	o.TimeZone = &v
}

// GetDefaultLanguage returns the DefaultLanguage field value if set, zero value otherwise.
func (o *Interaction) GetDefaultLanguage() string {
	if o == nil || IsNil(o.DefaultLanguage) {
		var ret string
		return ret
	}
	return *o.DefaultLanguage
}

// GetDefaultLanguageOk returns a tuple with the DefaultLanguage field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Interaction) GetDefaultLanguageOk() (*string, bool) {
	if o == nil || IsNil(o.DefaultLanguage) {
		return nil, false
	}
	return o.DefaultLanguage, true
}

// HasDefaultLanguage returns a boolean if a field has been set.
func (o *Interaction) HasDefaultLanguage() bool {
	if o != nil && !IsNil(o.DefaultLanguage) {
		return true
	}

	return false
}

// SetDefaultLanguage gets a reference to the given string and assigns it to the DefaultLanguage field.
func (o *Interaction) SetDefaultLanguage(v string) {
	o.DefaultLanguage = &v
}

// GetSuccessor returns the Successor field value if set, zero value otherwise.
func (o *Interaction) GetSuccessor() Successor {
	if o == nil || IsNil(o.Successor) {
		var ret Successor
		return ret
	}
	return *o.Successor
}

// GetSuccessorOk returns a tuple with the Successor field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Interaction) GetSuccessorOk() (*Successor, bool) {
	if o == nil || IsNil(o.Successor) {
		return nil, false
	}
	return o.Successor, true
}

// HasSuccessor returns a boolean if a field has been set.
func (o *Interaction) HasSuccessor() bool {
	if o != nil && !IsNil(o.Successor) {
		return true
	}

	return false
}

// SetSuccessor gets a reference to the given Successor and assigns it to the Successor field.
func (o *Interaction) SetSuccessor(v Successor) {
	o.Successor = &v
}

// GetCreatedAt returns the CreatedAt field value
func (o *Interaction) GetCreatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.CreatedAt
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value
// and a boolean to check if the value has been set.
func (o *Interaction) GetCreatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CreatedAt, true
}

// SetCreatedAt sets field value
func (o *Interaction) SetCreatedAt(v time.Time) {
	o.CreatedAt = v
}

// GetUpdatedAt returns the UpdatedAt field value
func (o *Interaction) GetUpdatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.UpdatedAt
}

// GetUpdatedAtOk returns a tuple with the UpdatedAt field value
// and a boolean to check if the value has been set.
func (o *Interaction) GetUpdatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.UpdatedAt, true
}

// SetUpdatedAt sets field value
func (o *Interaction) SetUpdatedAt(v time.Time) {
	o.UpdatedAt = v
}

func (o Interaction) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o Interaction) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["id"] = o.Id
	toSerialize["channel_id"] = o.ChannelId
	toSerialize["organization_id"] = o.OrganizationId
	toSerialize["name"] = o.Name
	toSerialize["priority"] = o.Priority
	toSerialize["action_executions_limit"] = o.ActionExecutionsLimit
	toSerialize["state"] = o.State
	toSerialize["trigger"] = o.Trigger
	toSerialize["actions"] = o.Actions
	toSerialize["force_new_transaction"] = o.ForceNewTransaction
	toSerialize["restart"] = o.Restart
	if !IsNil(o.RestartCoolDown) {
		toSerialize["restart_cool_down"] = o.RestartCoolDown
	}
	if !IsNil(o.LiveFrom) {
		toSerialize["live_from"] = o.LiveFrom
	}
	if !IsNil(o.LiveTo) {
		toSerialize["live_to"] = o.LiveTo
	}
	if !IsNil(o.Tags) {
		toSerialize["tags"] = o.Tags
	}
	if !IsNil(o.Languages) {
		toSerialize["languages"] = o.Languages
	}
	if !IsNil(o.Messengers) {
		toSerialize["messengers"] = o.Messengers
	}
	if !IsNil(o.Metrics) {
		toSerialize["metrics"] = o.Metrics
	}
	if !IsNil(o.TimeZone) {
		toSerialize["time_zone"] = o.TimeZone
	}
	if !IsNil(o.DefaultLanguage) {
		toSerialize["default_language"] = o.DefaultLanguage
	}
	if !IsNil(o.Successor) {
		toSerialize["successor"] = o.Successor
	}
	toSerialize["created_at"] = o.CreatedAt
	toSerialize["updated_at"] = o.UpdatedAt
	return toSerialize, nil
}

type NullableInteraction struct {
	value *Interaction
	isSet bool
}

func (v NullableInteraction) Get() *Interaction {
	return v.value
}

func (v *NullableInteraction) Set(val *Interaction) {
	v.value = val
	v.isSet = true
}

func (v NullableInteraction) IsSet() bool {
	return v.isSet
}

func (v *NullableInteraction) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableInteraction(val *Interaction) *NullableInteraction {
	return &NullableInteraction{value: val, isSet: true}
}

func (v NullableInteraction) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableInteraction) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


